import EventEmitter from 'eventemitter3';
export interface UnityInstance extends Record<string, any> {
    SetFullscreen: (fullScreen: 0 | 1) => void;
    SendMessage: (gameObject: string, method: string, param?: any) => void;
    Quit: () => Promise<void>;
}
declare global {
    interface Window {
        createUnityInstance(canvas: Element, config: {
            [key: string]: any;
        }, onProgress?: Function): Promise<UnityInstance>;
        $nuxtUnityEvent: EventEmitter;
    }
}
declare const useProvideNuxtUnity: (initialValue?: any, callback?: ((unityInstance: any) => void) | undefined) => void, useNuxtUnity: () => {
    unity: import("vue-demi").ShallowRef<UnityInstance | null>;
    loading: import("vue-demi").Ref<boolean>;
    loaded: import("vue-demi").Ref<boolean>;
    quitted: import("vue-demi").Ref<boolean>;
    quit: () => Promise<void>;
    error: import("vue-demi").Ref<Error | undefined>;
    SendMessage: <T = any>(gameObject: string, method: string, param?: T | undefined) => void;
    providerId: any;
    NuxtUnity: import("vue-demi").DefineComponent<{
        width: {
            type: StringConstructor;
            required: true;
        };
        height: {
            type: StringConstructor;
            required: true;
        };
        unityLoader: {
            type: StringConstructor;
            required: true;
        };
        onProgress: {
            type: FunctionConstructor;
            default: (progress: number) => void;
        };
        config: {
            type: ObjectConstructor;
            required: true;
        };
        resizable: {
            type: BooleanConstructor;
            default: boolean;
        };
        refreshDelayTime: {
            type: NumberConstructor;
            default: number;
        };
        resetOnRefresh: {
            type: BooleanConstructor;
            default: boolean;
        };
        onQuit: {
            type: FunctionConstructor;
            default: () => void;
        };
    }, {
        canvasWidth: import("vue-demi").Ref<string>;
        canvasHeight: import("vue-demi").Ref<string>;
        container: import("vue-demi").ShallowRef<HTMLElement | undefined>;
        canvas: import("vue-demi").ShallowRef<HTMLElement | undefined>;
    }, unknown, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, ("loading" | "loaded" | "error" | "quitting" | "quit")[], "loading" | "loaded" | "error" | "quitting" | "quit", import("vue-demi").VNodeProps & import("vue-demi").AllowedComponentProps & import("vue-demi").ComponentCustomProps, Readonly<import("vue-demi").ExtractPropTypes<{
        width: {
            type: StringConstructor;
            required: true;
        };
        height: {
            type: StringConstructor;
            required: true;
        };
        unityLoader: {
            type: StringConstructor;
            required: true;
        };
        onProgress: {
            type: FunctionConstructor;
            default: (progress: number) => void;
        };
        config: {
            type: ObjectConstructor;
            required: true;
        };
        resizable: {
            type: BooleanConstructor;
            default: boolean;
        };
        refreshDelayTime: {
            type: NumberConstructor;
            default: number;
        };
        resetOnRefresh: {
            type: BooleanConstructor;
            default: boolean;
        };
        onQuit: {
            type: FunctionConstructor;
            default: () => void;
        };
    }>> & {
        onQuit?: ((...args: any[]) => any) | undefined;
        onLoading?: ((...args: any[]) => any) | undefined;
        onLoaded?: ((...args: any[]) => any) | undefined;
        onError?: ((...args: any[]) => any) | undefined;
        onQuitting?: ((...args: any[]) => any) | undefined;
    }, {
        onQuit: Function;
        onProgress: Function;
        resizable: boolean;
        refreshDelayTime: number;
        resetOnRefresh: boolean;
    }>;
} | undefined;
export { useProvideNuxtUnity, useNuxtUnity };
export declare function useNuxtUnityOrThrow(): {
    unity: import("vue-demi").ShallowRef<UnityInstance | null>;
    loading: import("vue-demi").Ref<boolean>;
    loaded: import("vue-demi").Ref<boolean>;
    quitted: import("vue-demi").Ref<boolean>;
    quit: () => Promise<void>;
    error: import("vue-demi").Ref<Error | undefined>;
    SendMessage: <T = any>(gameObject: string, method: string, param?: T | undefined) => void;
    providerId: any;
    NuxtUnity: import("vue-demi").DefineComponent<{
        width: {
            type: StringConstructor;
            required: true;
        };
        height: {
            type: StringConstructor;
            required: true;
        };
        unityLoader: {
            type: StringConstructor;
            required: true;
        };
        onProgress: {
            type: FunctionConstructor;
            default: (progress: number) => void;
        };
        config: {
            type: ObjectConstructor;
            required: true;
        };
        resizable: {
            type: BooleanConstructor;
            default: boolean;
        };
        refreshDelayTime: {
            type: NumberConstructor;
            default: number;
        };
        resetOnRefresh: {
            type: BooleanConstructor;
            default: boolean;
        };
        onQuit: {
            type: FunctionConstructor;
            default: () => void;
        };
    }, {
        canvasWidth: import("vue-demi").Ref<string>;
        canvasHeight: import("vue-demi").Ref<string>;
        container: import("vue-demi").ShallowRef<HTMLElement | undefined>;
        canvas: import("vue-demi").ShallowRef<HTMLElement | undefined>;
    }, unknown, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, ("loading" | "loaded" | "error" | "quitting" | "quit")[], "loading" | "loaded" | "error" | "quitting" | "quit", import("vue-demi").VNodeProps & import("vue-demi").AllowedComponentProps & import("vue-demi").ComponentCustomProps, Readonly<import("vue-demi").ExtractPropTypes<{
        width: {
            type: StringConstructor;
            required: true;
        };
        height: {
            type: StringConstructor;
            required: true;
        };
        unityLoader: {
            type: StringConstructor;
            required: true;
        };
        onProgress: {
            type: FunctionConstructor;
            default: (progress: number) => void;
        };
        config: {
            type: ObjectConstructor;
            required: true;
        };
        resizable: {
            type: BooleanConstructor;
            default: boolean;
        };
        refreshDelayTime: {
            type: NumberConstructor;
            default: number;
        };
        resetOnRefresh: {
            type: BooleanConstructor;
            default: boolean;
        };
        onQuit: {
            type: FunctionConstructor;
            default: () => void;
        };
    }>> & {
        onQuit?: ((...args: any[]) => any) | undefined;
        onLoading?: ((...args: any[]) => any) | undefined;
        onLoaded?: ((...args: any[]) => any) | undefined;
        onError?: ((...args: any[]) => any) | undefined;
        onQuitting?: ((...args: any[]) => any) | undefined;
    }, {
        onQuit: Function;
        onProgress: Function;
        resizable: boolean;
        refreshDelayTime: number;
        resetOnRefresh: boolean;
    }>;
};
